#ifndef TYPON_RANDOM_HPP_INCLUDED
#define TYPON_RANDOM_HPP_INCLUDED

#include <random>


namespace typon
{

  struct Random
  {

    std::mt19937 _rng;

    Random() noexcept : _rng{std::random_device{}()} {}

    unsigned int operator()() noexcept
    {
      return _rng();
    }
  };

  namespace random
  {

    static thread_local Random random;

  }

}

#endif // TYPON_RANDOM_HPP_INCLUDED
